// naumann@stce.rwth-aachen.de

#include "f.hpp"

#include "dco.hpp"

#include<vector>
#include<cassert>

template<int N=50, typename T, typename PT>
void gradient(size_t ncp, size_t ncs, const PT &eps, T& x_v, std::vector<T>& p_v, const std::vector<std::vector<PT>> &dW, std::vector<T>& dxdp) {
  using DCO_T=typename dco::gt1v<T,N>::type;
  size_t n=p_v.size(); assert(n%N==0);
  DCO_T x; std::vector<DCO_T> p(n); dco::value(p)=p_v; 
  for (size_t j=0;j<n;j+=N) {
    x=x_v;
    for (size_t i=0;i<N;i++) dco::derivative(p[j+i])[i]=1;
    f(ncp,ncs,eps,x,p,dW);
    for (size_t i=0;i<N;i++) {
      dxdp[j+i]=dco::derivative(x)[i];
      dco::derivative(p[j+i])[i]=0;
    }
  }
  x_v=dco::value(x);
}  

#include "g_main.hpp"
